#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "cpu2device4xi5test.py">
#<abstract4xi abstract = "tests cpu4xi"/>
#<verify4xi verification = "11" target = "cpu2device4xi.py"/>
#<contextualize4xi context = "device4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'main',
            'print_trace4xi',
            'cpu2device4xi5test',
            'set_trace4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from cpu2device4xi import CPU4Xi                                                                                  # class to be tested 
from cpu2device4xi import init2cpu4xi                                                                             # function to be tested 
from cpu2device4xi import set2cpu4xi                                                                              # function to be tested 
from cpu2device4xi import get2cpu4xi                                                                              # function to be tested 

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
                                                                                                                  # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
     
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set_trace4xi" usage = "
#   setting trace using pickle4xi sub functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def set_trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    t2xi = Print4Xi()

    
    print('=' *33)
    print("(Step 1A/33) of SET_TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)")
    print('=' *33)
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
        
    keys2pickledb = sorted(PickleKB4Xi.keys())
    
    for key2pickledb in keys2pickledb:
     
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
        # STARTING LETTER :  _    

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        
        # print('~' *33)        
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # STARTING DICTIONARY:  {'xml_trace_sense4xi': 'NACK4XI', '_reduce_partial4xi': 'NACK4XI', 'set_listener4xi': 'NACK4XI', 'sense_lock4xi': 'NACK4XI', '_run_after_forkers4xi ': 'NACK4XI', 'ace_cache4xi': 'NACK4XI', 'xml_trace_reason4xi': 'NACK4XI', 'reason_cache4xi': 'NACK4XI', '_rebuild_partial4xi': 'NACK4XI', 'init_listener4xi': 'NACK4XI', '_MainProcess4Xi': 'NACK4XI', 'close_cache4xi': 'NACK4XI', '_xml_loads4xi': 'NACK4XI', 'ace_listener4xi': 'NACK4XI', '_xml_dumps4xi': 'NACK4XI', '_cleanup4xi': 'NACK4XI', '_serve4xi': 'NACK4XI', 'reason_listener4xi': 'NACK4XI', '_run_after_forkers4xi': 'NACK4XI', '_exit_function4xi': 'NACK4XI', 'clear_cache4xi': 'NACK4XI', '_finalizer4xi': 'NACK4XI', 'ace_lock4xi': 'NACK4XI', 'acquire_lock4xi': 'NACK4XI', '_get_listener4xi': 'NACK4XI', 'sense_listener4xi': 'NACK4XI', 'release_lock4xi': 'NACK4XI', 'get_cache4xi': 'NACK4XI', 'init_cache4xi': 'NACK4XI', 'reason_lock4xi': 'NACK4XI', '_reduce_method_descriptor4xi': 'NACK4XI', 'reset_cache4xi': 'NACK4XI', '_reset4xi': 'NACK4XI', 'add_cache4xi': 'NACK4XI', 'reset_listener4xi': 'NACK4XI', '_run_finalizers4xi': 'NACK4XI', 'remove_cache4xi': 'NACK4XI', '_new_value4xi': 'NACK4XI', 'sense_cache4xi': 'NACK4XI', 'get_listener4xi': 'NACK4XI', '_bootstrap4xi': 'NACK4XI', 'xml_trace_ace4xi': 'NACK4XI', 'get_lock4xi': 'NACK4XI', '_C4Xi': 'NACK4XI', '_check_logger_class4xi': 'NACK4XI', 'init_lock4xi': 'NACK4XI', '_reduce_method4xi': 'NACK4XI', 'reset_lock4xi': 'NACK4XI'}

                    
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # _C4Xi, _MainProcess4Xi, _bootstrap4xi ....  
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            

            # ---------------------------------------------------------------------------------    
            # skip pickling
            # ---------------------------------------------------------------------------------     
        
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                print("SET_TRACE4XI.PY - MARKED TO BE TRACED OBJECT: ", object2pickle)                              # SET_TRACE4XI.PY - MARKED TO BE TRACED OBJECT:  
                                                                                                                    # get2cpu4xi
                                                                                                                                                                                                                                     # init2cpu4xi
                                                                                                                    # init2cpu4xi
                                                                                                                    
                                                                                                                    # CPU4Xi
                                                                                                                    
                                                                                                                    # set2cpu4xi
                                                                                                                    
            
                dictionary2pickle[key2dictionary] = 'TRACE4XI' 
                # print('~' *33)
            else:
                pass  
                   
                                         
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("*** ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
            

        
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
            
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # COMPLETED  DICTIONARY:
        #  {'xml_trace_sense4xi': 'ACK4XI', '_reduce_partial4xi': 'ACK4XI', 'set_listener4xi': 'ACK4XI', 'sense_lock4xi': 'ACK4XI', '_run_after_forkers4xi ': 'ACK4XI', 'ace_cache4xi': 'ACK4XI', 'xml_trace_reason4xi': 'ACK4XI', 'reason_cache4xi': 'ACK4XI', '_rebuild_partial4xi': 'ACK4XI', 'init_listener4xi': 'ACK4XI', '_MainProcess4Xi': 'ACK4XI', 'close_cache4xi': 'ACK4XI', '_xml_loads4xi': 'ACK4XI', 'ace_listener4xi': 'ACK4XI', '_xml_dumps4xi': 'ACK4XI', '_cleanup4xi': 'ACK4XI', '_serve4xi': 'ACK4XI', 'reason_listener4xi': 'ACK4XI', '_run_after_forkers4xi': 'ACK4XI', '_exit_function4xi': 'ACK4XI', 'clear_cache4xi': 'ACK4XI', '_finalizer4xi': 'ACK4XI', 'ace_lock4xi': 'ACK4XI', 'acquire_lock4xi': 'ACK4XI', '_get_listener4xi': 'ACK4XI', 'sense_listener4xi': 'ACK4XI', 'release_lock4xi': 'ACK4XI', 'get_cache4xi': 'ACK4XI', 'init_cache4xi': 'ACK4XI', 'reason_lock4xi': 'ACK4XI', '_reduce_method_descriptor4xi': 'ACK4XI', 'reset_cache4xi': 'ACK4XI', '_reset4xi': 'ACK4XI', 'add_cache4xi': 'ACK4XI', 'reset_listener4xi': 'ACK4XI', '_run_finalizers4xi': 'ACK4XI', 'remove_cache4xi': 'ACK4XI', '_new_value4xi': 'ACK4XI', 'sense_cache4xi': 'ACK4XI', 'get_listener4xi': 'ACK4XI', '_bootstrap4xi': 'ACK4XI', 'xml_trace_ace4xi': 'ACK4XI', 'get_lock4xi': 'ACK4XI', '_C4Xi': 'ACK4XI', '_check_logger_class4xi': 'ACK4XI', 'init_lock4xi': 'ACK4XI', '_reduce_method4xi': 'ACK4XI', 'reset_lock4xi': 'ACK4XI'}

        
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
                    
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # COMPLETED LETTER :  _, a ... z            
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------  
           
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
 
    print('=' *33)
    print("(Step 33/33) of SET_TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)")
    print('=' *33)
            
#</function4xi> 
       

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace for cpu4xi test
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-cpu2device4xi5test.xml',
     'name_space4xi': '   xmlns="http://www..com/sense/sw/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing CPU in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">CPU sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-cpu2device4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi.com/reason/sw/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for CPU in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-cpu2device4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi.com/ace/sw/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for CPU in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of CPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "cpu2device4xi5test" usage = "
# tests cpu4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def cpu2device4xi5test():
    global t2xi 
    global trace_object_count
    
    # ---------------------------------------------------------------------------------------------    
    # Set Trace
    # ---------------------------------------------------------------------------------------------     
    set_trace4xi()

    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 1A/33) OF CPU4XI5TEST - STARTED ', time4xi())
    print('=' *33)   
    
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS                          
    # ---------------------------------------------------------------------------------------------
    
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) OF CPU4XI5TEST - TRYING TO INITIALIZE CPU4XI', time4xi())
    print('=' *33)       
    try:
        cpu2xi = init2cpu4xi()                                                                                      # no parameters - the system should initialize all   
        print('(Step 2B/33) OF CPU4XI5TEST - INITIALIZED CPU4XI TO: ', cpu2xi)
        # {'RESOLUTION2TIMER4PROFILING': 318,
        #  'ID2PLATFORM': '0000000001509568',
        #  'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 2,
        #  'MAX2UNITS4COMPUTE': 4,
        #  'SIZE2MEMORY4GLOBAL': 3221225472,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 4,
        #  'MAX2SIZE4WORKGROUP': 1024,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 65536,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
        #  'TYPE4CACHE': 'Read/Write',
        #  'PREFERRED2WIDTHINT4VECTOR': 4,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
        #  'NATIVE2WIDTHINT4VECTOR': 4,
        #  'SIZE2BUFFER4CONSTANT': 65536,
        #  'EXECUTE2FUNCTION4NATIVE': 'ACK',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
        #  'MAX2NUMBER4CONSTANTARGS': 8,
        #  'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK',
        #  'MAX2DIMENSIONS4WORKITEMS': 3,
        #  'SUPPORT2CORRECTION4ERROR': 0,
        #  'BITS2ADDRESS': 64,
        #  'AVAILABLE': 'ACK',
        #  'SIZE2MEMORY4LOCAL': 32768,
        #  'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK',
        #  'MAX2SIZE4KERNELARGUMENT': 4096,
        #  'OUT-OF-ORDER2QUEUE': 'NACK',
        #  'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE',
        #  'TYPE2MEMORY4LOCAL': 'Global',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 4,
        #  'PREFERRED2WIDTHLONG4VECTOR': 2,
        #  'MAX2FREQUENCY4CLOCK': 3210,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4017,
        #  'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'MAX2WORKITEM2': 1024,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 0,
        #  'ROUND2ZERO': 'ACK',
        #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 
        #  'MAX2WORKITEM1': 1024,
        #  'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64,
        #  'MAX2ALLOCATION4MEMORY': 1073741824,
        #  'NATIVE2WIDTHCHAR4VECTOR': 16,
        #  'QUIET2NANS': 'ACK',
        #  'NATIVE2WIDTHSHORT4VECTOR': 8,
        #  'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
        #  'NACK2RETURN': ' ',
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 1,
        #  'ENDIANESS2DEVICE': 'Little',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_CPU',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}
                                      
    except:
        print('(Step 2Z/33) OF CPU4XI5TEST *** FAILED TO INITIALIZE CPU4XI', time4xi()) 
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) OF CPU4XI5TEST - TRYING TO GET CPU4XI', time4xi())
    print('=' *33)    
    try:
        
        cpu2xi = get2cpu4xi()
        print('(Step 3B/33) OF CPU4XI5TEST - GOT CPU4XI: ', cpu2xi)                                                 # {'NACK2RETURN': ' ', 'ACK2RETURN': ' 1C1D1E1F2A3A4A', 
                                                                                                                    # 'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 'CPU', 'MAX2UNITS4COMPUTE': 4} 

    except:
        print('(Step 3Z/33) OF CPU4XI5TEST *** FAILED TO GET CPU4XI', time4xi())
            
    
    # ---------------------------------------------------------------------------------------------
    # SET CPU's ID, TYPE, MAXIMUM COMPUTE UNITS WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4A/33) OF CPU4XI5TEST - TRYING TO SET CPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi())
    print('=' *33)       
    task4set2cpu = {}
    task4set2cpu['ID'] = 4098
    task4set2cpu['TYPE'] = 'CL_DEVICE_TYPE_CPU'
    task4set2cpu['MAX2UNITS4COMPUTE'] = 0                                                                           # ZERO CORES
    
     
    try:                               
        response4set2cpu = set2cpu4xi(task4set2cpu)                                                       
        print('(Step 4B/33) OF CPU4XI5TEST - RESPONSE4SET2CPU : ', response4set2cpu)                                
        # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 
        #  'MAX2UNITS4COMPUTE': 4, <-- SET PROPERLY BY SYSTEM ! 
        #  'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4098, 'ACK2RETURN': ' 2A3A4A4B4H', 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}

        
    except:
        print('(Step 4Z1/33) OF CPU4XI5TEST *** FAILED TO SET CPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi())  
        
    task4set2cpu['MAX2UNITS4COMPUTE'] = 2                                                                           # LESS THAN POSSIBLE 
    try:                               
        response4set2cpu = set2cpu4xi(task4set2cpu)                                                       
        print('(Step 4C/33) OF CPU4XI5TEST - RESPONSE4SET2CPU : ', response4set2cpu)                                # {'NACK2RETURN': ' 4E', 'ACK2RETURN': ' 2A3A4A4C4D', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4098, 
                                                                                                                    # 'MAX2UNITS4COMPUTE': 2}
                                                                                                                    # { set2cpu4xi : set2cpu4xi ; (Step 4D/33) set; max2units4compute-set-by-set2cpu4xi to: 2; time: 07:54:07 05/02/11 Pacific Daylight Time}
                                                                                                                    # { set2cpu4xi : set2cpu4xi ; (Step 4E/33) warned; cores2xi-warned-by-set2cpu4xi:  ** 4 ** ; time: 07:54:07 05/02/11 Pacific Daylight Time}
        
    except:
        print('(Step 4Z2/33) OF CPU4XI5TEST *** FAILED TO SET CPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi()) 
        
    task4set2cpu['MAX2UNITS4COMPUTE'] = 100                                                                         # TOO MANY CORES 
    try:                               
        response4set2cpu = set2cpu4xi(task4set2cpu)                                                       
        print('(Step 4D/33) OF CPU4XI5TEST - RESPONSE4SET2CPU : ', response4set2cpu)                                # { set2cpu4xi : set2cpu4xi ; (Step 4G/33) warned; cores2xi-warned-by-set2cpu4xi:  ** 4 ** ; time: 07:54:07 05/02/11 Pacific Daylight Time}
                                                                                                                    # { set2cpu4xi : set2cpu4xi ; (Step 4H/33) set; max2units4compute-set-by-set2cpu4xi to: 4; time: 07:54:07 05/02/11 Pacific Daylight Time}
                                                                                                                    # { set2cpu4xi : set2cpu4xi ; (Step 33/33) returning; cpu2device4xi-returning-by-set2cpu4xi: {'NACK2RETURN': ' 4G', 'ACK2RETURN': ' 2A3A4A4C4F4H', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4098, 'MAX2UNITS4COMPUTE': 4}; time: 07:54:07 05/02/11 Pacific Daylight Time}
                                                                                                                    # (Step 4D/33) OF CPU4XI5TEST - RESPONSE4SET2CPU :  {'NACK2RETURN': ' 4G', 'ACK2RETURN': ' 2A3A4A4C4F4H', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4098, 'MAX2UNITS4COMPUTE': 4}
    except:
        print('(Step 4Z3/33) OF CPU4XI5TEST *** FAILED TO SET CPU ID, TYPE AND MAXIMUM COMPUTE UNITS ', time4xi()) 
           
    # ---------------------------------------------------------------------------------------------
    # PHASE II: class tests                          
    # ---------------------------------------------------------------------------------------------
    print('=' *33)          
    print('(Step 5A/33) OF CPU4XI5TEST - CREATING CPU4XI OBJECT')
    print('=' *33)  
    try:
        # ---------------------------------------------------------------------------------------------
        # CREATE OBJECT                        
        # ---------------------------------------------------------------------------------------------        
        cc2xi = CPU4Xi()
        print('(Step 5B/33) OF CPU4XI5TEST - CREATED CPU4XI OBJECT: ', cc2xi)                                       # <cpu2device4xi.CPU4Xi object at 0x000000000331B630> 
    except:
        print('(Step 5Z/33) OF CPU4XI5TEST *** FAILED TO CREATE CPU4XI OBJECT')
    
    # ---------------------------------------------------------------------------------------------
    # GET METHOD                        
    # ---------------------------------------------------------------------------------------------          
    print('(Step 6A/33) OF CPU4XI5TEST - TRYING TO GET CPU')
    try:                               
        cpu6xi = cc2xi.get2cpu()                                  
        print('(Step 6B/33) OF CPU4XI5TEST - GOT CPU: ', cpu6xi)                                                    
        # {'RESOLUTION2TIMER4PROFILING': 318,
        #  'ID2PLATFORM': '0000000001509568',
        #  'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 2,
        #  'MAX2UNITS4COMPUTE': 4,
        #  'SIZE2MEMORY4GLOBAL': 3221225472,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 4,
        #  'MAX2SIZE4WORKGROUP': 1024,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 65536,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
        #  'TYPE4CACHE': 'Read/Write',
        #  'PREFERRED2WIDTHINT4VECTOR': 4,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
        #  'NATIVE2WIDTHINT4VECTOR': 4,
        #  'SIZE2BUFFER4CONSTANT': 65536,
        #  'EXECUTE2FUNCTION4NATIVE': 'ACK',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
        #  'MAX2NUMBER4CONSTANTARGS': 8,
        #  'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK',
        #  'MAX2DIMENSIONS4WORKITEMS': 3,
        #  'SUPPORT2CORRECTION4ERROR': 0,
        #  'BITS2ADDRESS': 64,
        #  'AVAILABLE': 'ACK',
        #  'SIZE2MEMORY4LOCAL': 32768,
        #  'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK',
        #  'MAX2SIZE4KERNELARGUMENT': 4096,
        #  'OUT-OF-ORDER2QUEUE': 'NACK',
        #  'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE',
        #  'TYPE2MEMORY4LOCAL': 'Global',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 4,
        #  'PREFERRED2WIDTHLONG4VECTOR': 2,
        #  'MAX2FREQUENCY4CLOCK': 3210,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4017,
        #  'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'MAX2WORKITEM2': 1024,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 0,
        #  'ROUND2ZERO': 'ACK', 
        #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 
        #  'MAX2WORKITEM1': 1024,
        #  'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64,
        #  'MAX2ALLOCATION4MEMORY': 1073741824,
        #  'NATIVE2WIDTHCHAR4VECTOR': 16,
        #  'QUIET2NANS': 'ACK',
        #  'NATIVE2WIDTHSHORT4VECTOR': 8,
        #  'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
        #  'NACK2RETURN': ' ',
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 1,
        #  'ENDIANESS2DEVICE': 'Little',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_CPU',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}

    except:
        print('(Step 6Z/33) OF CPU4XI5TEST *** FAILED TO GET CPU')   
     
    
    
    # ---------------------------------------------------------------------------------------------
    # INIT CPU's ID, TYPE AND MAX COMPUTING UNITS WITH METHOD                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 7A/33) OF CPU4XI5TEST - TRYING TO INIT CPU ID AND TYPE', time4xi())
    print('=' *33)       
    task4set2cpu = {} 
    task4set2cpu['ID'] = 4098
    task4set2cpu['TYPE'] = 'CL_DEVICE_TYPE_CPU'
    task4set2cpu['MAX2UNITS4COMPUTE'] = 2                                                                           # 2 CORES
  
    try:                               
        response4set2cpu = cc2xi.init2cpu(task4set2cpu)                                                        
        print('(Step 7B/33) OF CPU4XI5TEST - RESPONSE4SET2CPU : ', response4set2cpu)                                # {'NACK2RETURN': ' 5Z1', <-- name NOT initialized !
                                                                                                                    #   'ACK2RETURN': ' 1C2A3A4A', 
                                                                                                                    #         'TYPE': 'CL_DEVICE_TYPE_CPU', 
                                                                                                                    #           'ID': 4098, 
                                                                                                                    #   'MAX2UNITS4COMPUTE': 2}
 
    except:
        print('(Step 7Z1/33) OF CPU4XI5TEST *** FAILED TO SET CPU ID AND TYPE ', time4xi())   
        
    
    # ---------------------------------------------------------------------------------------------
    # RESET CPU GIVING ALL ATTRIBUTES - DEPICT WITH 8                      
    # ---------------------------------------------------------------------------------------------          
    print('=' *33)          
    print('(Step 8A/33) OF CPU4XI5TEST - TRYING TO SET ALL ATTRIBUTES TO CPU ', time4xi())   
    print('=' *33)       
    task4set2cpu = {}
    task4set2cpu['ID'] = 40988
    task4set2cpu['TYPE'] = 'CL_DEVICE_TYPE_CPU8'
    task4set2cpu['MAX2UNITS4COMPUTE'] = 8                                                                           # CORES
    task4set2cpu['NAME'] = 'AMD Phenom(tm) II X4 955 Processor8'                                                    # OPENCL NAME 
    task4set2cpu['RESOLUTION2TIMER4PROFILING'] = 3188
    task4set2cpu['ID2PLATFORM'] = '00000000015095688'
    task4set2cpu['PROFILING2QUEUE'] = 'ACK8'
    task4set2cpu['EXECUTE2KERNELS4OPENCL'] = 'ACK8'
    task4set2cpu['NATIVE2WIDTHLONG4VECTOR'] = 28
    task4set2cpu['MAX2UNITS4COMPUTE'] = 48
    task4set2cpu['SIZE2MEMORY4GLOBAL'] = 32212254728
    task4set2cpu['NATIVE2WIDTHFLOAT4VECTOR'] = 48
    task4set2cpu['MAX2SIZE4WORKGROUP'] = 10248
    task4set2cpu['PREFERRED2WIDTHCHAR4VECTOR'] = 168
    task4set2cpu['SIZE2CACHE'] = 655368
    task4set2cpu['IEEE754-2008FUSED2MULTIPLY-ADD'] = 'NACK8'
    task4set2cpu['TYPE4CACHE'] = 'Read/Write8'
    task4set2cpu['PREFERRED2WIDTHINT4VECTOR'] = 48
    task4set2cpu['SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL'] = 18
    task4set2cpu['NATIVE2WIDTHINT4VECTOR'] = 48
    task4set2cpu['SIZE2BUFFER4CONSTANT'] = 655368
    task4set2cpu['EXECUTE2FUNCTION4NATIVE'] = 'ACK8'
    task4set2cpu['PREFERRED2WIDTHDOUBLE4VECTOR'] = 8
    task4set2cpu['MAX2NUMBER4CONSTANTARGS'] = 88
    task4set2cpu['VERSION2DRIVER'] = '2.08'
    task4set2cpu['EXTENSIONS'] = 'cl_amd_fp648 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing'
    task4set2cpu['AVAILABLE2COMPILER'] = 'ACK8'
    task4set2cpu['MAX2DIMENSIONS4WORKITEMS'] = 38
    task4set2cpu['SUPPORT2CORRECTION4ERROR'] = 8
    task4set2cpu['BITS2ADDRESS'] = 648
    task4set2cpu['AVAILABLE'] = 'ACK8'
    task4set2cpu['SIZE2MEMORY4LOCAL'] = 327688
    task4set2cpu['VENDOR'] = 'AuthenticAMD8'
    task4set2cpu['SUPPORT2IMAGE'] = 'NACK8'
    task4set2cpu['MAX2SIZE4KERNELARGUMENT'] = 40968
    task4set2cpu['OUT-OF-ORDER2QUEUE'] = 'NACK8'
    task4set2cpu['ALIGNMENT2ADDRESS4BASE'] = 10248
    task4set2cpu['PROFILE'] = 'FULL_PROFILE8'
    task4set2cpu['TYPE2MEMORY4LOCAL'] = 'Global8'
    task4set2cpu['PREFERRED2WIDTHFLOAT4VECTOR'] = 48
    task4set2cpu['PREFERRED2WIDTHLONG4VECTOR'] = 28
    task4set2cpu['MAX2FREQUENCY4CLOCK'] = 32108
    task4set2cpu['PREFERRED2WIDTHSHORT4VECTOR'] = 88
    task4set2cpu['ID'] = 40178
    task4set2cpu['MAX2WORKITEM2'] = 10248
    task4set2cpu['NATIVE2WIDTHDOUBLE4VECTOR'] = 8
    task4set2cpu['ROUND2ZERO'] = 'ACK8' 
    task4set2cpu['NAME'] = 'AMD64 Family 16 Model 4 Stepping 2 AuthenticAMD8'
    task4set2cpu['MAX2WORKITEM1'] = 10248
    task4set2cpu['MAX2WORKITEM0'] = 10248
    task4set2cpu['SIZE2LINE4CACHE'] = 648
    task4set2cpu['MAX2ALLOCATION4MEMORY'] = 10737418248
    task4set2cpu['NATIVE2WIDTHCHAR4VECTOR'] = 168
    task4set2cpu['QUIET2NANS'] = 'ACK8'
    task4set2cpu['NATIVE2WIDTHSHORT4VECTOR'] = 88
    task4set2cpu['ROUND2NEAREST4EVEN'] = 'ACK8'
    task4set2cpu['VERSION'] = 'OpenCL 1.1 ATI-Stream-v2.3 (4518)'
    task4set2cpu['MEMORY2UNIFIED4HOSTANDDEVICE'] = 18
    task4set2cpu['ENDIANESS2DEVICE'] = 'Little8'
    task4set2cpu['MINIMUM2ALIGNMENT4DATATYPE'] = 1288
    task4set2cpu['ROUND2+VE3INFINITY'] = 'ACK8'
    task4set2cpu['TYPE'] = 'CL_DEVICE_TYPE_CPU8'
    task4set2cpu['DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY'] = 'ACK8'
    
    
    try:                               
        response4set2cpu = cc2xi.set2cpu(task4set2cpu)                                                        
        print('(Step 8B/33) OF CPU4XI5TEST - RESPONSE4SET2CPU : ', response4set2cpu)    
        # {'RESOLUTION2TIMER4PROFILING': 3188,
        #  'ID2PLATFORM': '00000000015095688',
        #  'PROFILING2QUEUE': 'ACK8',
        #  'SIZE2BUFFER4CONSTANT': 655368,
        #  'EXECUTE2KERNELS4OPENCL': 'ACK8',
        #  'NATIVE2WIDTHLONG4VECTOR': 28,
        #  'SIZE2MEMORY4GLOBAL': 32212254728,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 48,
        #  'MAX2SIZE4WORKGROUP': 10248,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 168,
        #  'SIZE2CACHE': 655368,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK8',
        #  'TYPE4CACHE': 'Read/Write8',
        #  'PREFERRED2WIDTHINT4VECTOR': 48,
        #  'MAX2FREQUENCY4CLOCK': 32108,
        #  'NATIVE2WIDTHINT4VECTOR': 48,
        #  'ACK2RETURN': ' 2A3A4A4C4F4H5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'EXECUTE2FUNCTION4NATIVE': 'ACK8',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 8,
        #  'MAX2NUMBER4CONSTANTARGS': 88,
        #  'VERSION2DRIVER': '2.08',
        #  'EXTENSIONS': 'cl_amd_fp648 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK8',
        #  'MAX2DIMENSIONS4WORKITEMS': 38,
        #  'SUPPORT2CORRECTION4ERROR': 8,
        #  'BITS2ADDRESS': 648,
        #  'AVAILABLE': 'ACK8',
        #  'SIZE2MEMORY4LOCAL': 327688,
        #  'VENDOR': 'AuthenticAMD8',
        #  'SUPPORT2IMAGE': 'NACK8',
        #  'MAX2SIZE4KERNELARGUMENT': 40968,
        #  'OUT-OF-ORDER2QUEUE': 'NACK8',
        #  'ALIGNMENT2ADDRESS4BASE': 10248,
        #  'PROFILE': 'FULL_PROFILE8',
        #  'TYPE2MEMORY4LOCAL': 'Global8',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 48,
        #  'PREFERRED2WIDTHLONG4VECTOR': 28,
        #  'MAX2UNITS4COMPUTE': 4,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 88,
        #  'ID': 40178,
        #  'MAX2WORKITEM2': 10248,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 8,
        #  'ROUND2ZERO': 'ACK8',
        #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2 AuthenticAMD8',
        #  'MAX2WORKITEM1': 10248,
        #  'NATIVE2WIDTHCHAR4VECTOR': 168,
        #  'SIZE2LINE4CACHE': 648,
        #  'MAX2ALLOCATION4MEMORY': 10737418248,
        #  'MAX2WORKITEM0': 10248,
        #  'QUIET2NANS': 'ACK8',
        #  'NATIVE2WIDTHSHORT4VECTOR': 88,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 18,
        #  'ROUND2NEAREST4EVEN': 'ACK8',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (4518)',
        #  'NACK2RETURN': ' 4G', <-- TOO MANY CORES WANTED FOR OPENCL OPERATIONS
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 18,
        #  'ENDIANESS2DEVICE': 'Little8',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 1288,
        #  'ROUND2+VE3INFINITY': 'ACK8',
        #  'TYPE': 'CL_DEVICE_TYPE_CPU8',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK8'}

                               

    except:
        print('(Step 8Z1/33) OF CPU4XI5TEST *** FAILED TO SET CPU ID AND TYPE ', time4xi())   
        
     
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH METHOD AFTER RESET                    
    # ---------------------------------------------------------------------------------------------          
    print('(Step 12A/33) OF CPU4XI5TEST - TRYING TO GET DEVICE')
    try:                               
        cpu12xi = cc2xi.get2cpu()                                  
        print('(Step 12B/33) OF CPU4XI5TEST - GOT CPU: ', cpu12xi)                                                 
        # {'RESOLUTION2TIMER4PROFILING': 3188,
        #  'ID2PLATFORM': '00000000015095688',
        #  'PROFILING2QUEUE': 'ACK8',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK8',
        #  'NATIVE2WIDTHLONG4VECTOR': 28,
        #  'SIZE2MEMORY4GLOBAL': 32212254728,
        #  'NATIVE2WIDTHFLOAT4VECTOR': 48,
        #  'MAX2SIZE4WORKGROUP': 10248,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 168,
        #  'SIZE2CACHE': 655368,
        #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK8',
        #  'TYPE4CACHE': 'Read/Write8',
        #  'PREFERRED2WIDTHINT4VECTOR': 48,
        #  'MAX2FREQUENCY4CLOCK': 32108,
        #  'NATIVE2WIDTHINT4VECTOR': 48,
        #  'SIZE2BUFFER4CONSTANT': 655368,
        #  'EXECUTE2FUNCTION4NATIVE': 'ACK8',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 8,
        #  'MAX2NUMBER4CONSTANTARGS': 88,
        #  'VERSION2DRIVER': '2.08',
        #  'EXTENSIONS': 'cl_amd_fp648 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK8',
        #  'MAX2DIMENSIONS4WORKITEMS': 38,
        #  'SUPPORT2CORRECTION4ERROR': 8,
        #  'BITS2ADDRESS': 648,
        #  'AVAILABLE': 'ACK8',
        #  'SIZE2MEMORY4LOCAL': 327688,
        #  'VENDOR': 'AuthenticAMD8',
        #  'SUPPORT2IMAGE': 'NACK8',
        #  'MAX2SIZE4KERNELARGUMENT': 40968,
        #  'ACK2RETURN': ' 2A3A4A4C4F4H5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A',
        #  'OUT-OF-ORDER2QUEUE': 'NACK8',
        #  'ALIGNMENT2ADDRESS4BASE': 10248,
        #  'PROFILE': 'FULL_PROFILE8',
        #  'TYPE2MEMORY4LOCAL': 'Global8',
        #  'PREFERRED2WIDTHFLOAT4VECTOR': 48,
        #  'PREFERRED2WIDTHLONG4VECTOR': 28,
        #  'MAX2UNITS4COMPUTE': 4,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 88,
        #  'ID': 40178,
        #  'MAX2WORKITEM2': 10248,
        #  'NATIVE2WIDTHDOUBLE4VECTOR': 8,
        #  'ROUND2ZERO': 'ACK8',
        #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2 AuthenticAMD8',
        #  'MAX2WORKITEM1': 10248,
        #  'NATIVE2WIDTHCHAR4VECTOR': 168,
        #  'SIZE2LINE4CACHE': 648,
        #  'MAX2ALLOCATION4MEMORY': 10737418248,
        #  'MAX2WORKITEM0': 10248,
        #  'QUIET2NANS': 'ACK8',
        #  'NATIVE2WIDTHSHORT4VECTOR': 88,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 18,
        #  'ROUND2NEAREST4EVEN': 'ACK8',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (4518)',
        #  'NACK2RETURN': ' 4G',
        #  'MEMORY2UNIFIED4HOSTANDDEVICE': 18,
        #  'ENDIANESS2DEVICE': 'Little8',
        #  'MINIMUM2ALIGNMENT4DATATYPE': 1288,
        #  'ROUND2+VE3INFINITY': 'ACK8',
        #  'TYPE': 'CL_DEVICE_TYPE_CPU8',
        #  'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK8'}

    except:
        print('(Step 12Z/33) OF CPU4XI5TEST *** FAILED TO GET DEVICE')          
           
    # ---------------------------------------------------------------------------------------------
    # SENSE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 15A/33) OF CPU4XI5TEST - SENSING ', time4xi())
    print('=' *33)      
    
    try:
        print(cc2xi.sense())
    
        print('=' *33)          
        print('(Step 15B/33) OF CPU4XI5TEST - SENSED ', time4xi())                                                  # {'object': <cpu2device4xi.CPU4Xi object at 0x00000000033F1860>, 
                                                                                                                    # 'classvariable2cpu-of-CPU4Xi': 4}
        print('=' *33)
    except:
        print('(Step 15Z/33) OF CPU4XI5TEST *** FAILED TO SENSE ', time4xi())          
        
    # ---------------------------------------------------------------------------------------------
    # REASON                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 17A/33) OF CPU4XI5TEST - REASONING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.reason())
    
        print('=' *33)          
        print('(Step 17B/33) OF CPU4XI5TEST - REASONED ', time4xi())                                                # <cpu2device4xi.CPU4Xi object at 0x00000000033F1860>, 'time-reason-of-CPU4Xi': '08:52:35 05/02/11 Pacific Daylight Time'}
        print('=' *33)       
    except:
        print('(Step 17Z/33) OF CPU4XI5TEST *** FAILED TO REASON ', time4xi())                                      
             
    # ---------------------------------------------------------------------------------------------
    # ACE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 21A/33) OF CPU4XI5TEST - ACING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.ace())
    
        print('=' *33)          
        print('(Step 21B/33) OF CPU4XI5TEST - ACED ', time4xi())                                                    # kb8xi-returning-by-ace-of-CPU4Xi: {'cores-of-CPU4Xi': 4, 'object8xi': <cpu2device4xi.CPU4Xi object at 0x00000000033F1860>}
        print('=' *33) 
    except:
        print('(Step 21Z/33) OF CPU4XI5TEST *** FAILED TO ACE ', time4xi())                                                
     
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33/33) OF CPU4XI5TEST - DONE! ', time4xi())                                                        # 08:52:35 05/02/11 Pacific Daylight Time
    print('=' *33) 
        
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print_trace4xi(t2xi)        
           
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for cpu2device4xi5test
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():
       
    print('=' *33)
    print("(Step 0A/33) OF CPU4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi())  
    print('=' *33)
        
    cpu2device4xi5test()  
    
    print('=' *33)
    print("(Step 0B/33) OF CPU4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi())    
    print('=' *33) 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# cpu2device4xi5test.txt
# sense-cpu2device4xi5test.xml
# reason-cpu2device4xi5test.xml
# ace-cpu2device4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of cpu2device4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
